#include <unordered_map>
#include <chrono>
#include <iostream>
#include <vector>
#include <utility>

constexpr std::uint64_t iterations = 10000000;

int main(void) {

    {
        std::chrono::steady_clock::time_point start = std::chrono::steady_clock::now();
        std::unordered_map<std::uint64_t,std::uint64_t> map1;
        for (std::uint64_t i=0; i<iterations; i++) {
            map1.emplace(i,i);
        }
        std::chrono::steady_clock::time_point end = std::chrono::steady_clock::now();
        std::cout << "Done in "
              << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count() << "ms"
              << std::endl;
    }

    {
        std::unordered_map<std::uint64_t,std::uint64_t> map2;
        std::vector<std::pair<std::uint64_t,std::uint64_t>> vec2;
        for (std::uint64_t i=0; i<iterations; i++) {
          vec2.emplace_back(i,i);
        }
        std::chrono::steady_clock::time_point start = std::chrono::steady_clock::now();
        map2.insert(vec2.begin(), vec2.end());
        std::chrono::steady_clock::time_point end = std::chrono::steady_clock::now();
        std::cout << "Done in "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count() << "ms"
                  << std::endl;
    }
}
